# $Revision: 1.65 $, $Date: 2012/01/13 20:59:53 $
# NOTE: Building requires working DNS setup. Build may hang
#       even if _only_ first dns specified in resolv.conf
#       is unreachable.
# TODO
# - separate -devel (at least header files!)
# - modularize (odbc, etc)
# - manuals to %{_mandir}
# - investigate fPIC.patch
#
# Conditional build:
%bcond_with	java		# with Java support
%bcond_without	odbc		# without unixODBC support
#
Summary:	OpenSource Erlang/OTP
Summary(pl.UTF-8):	Erlang/OTP z otwartymi źródłami
Name:		erlang
# A - unstable, B - stable line, keep stable
Version:	R14B03
Release:	3
Epoch:		1
%define		_version	%(echo %{version} | tr _ -)
License:	distributable
Group:		Development/Languages
Source0:	http://www.erlang.org/download/otp_src_%{_version}.tar.gz
# Source0-md5:	7979e662d11476b97c462feb7c132fb7
Source1:	http://www.erlang.org/download/otp_doc_man_%{_version}.tar.gz
# Source1-md5:	357f54b174bb29d41fee97c063a47e8f
Patch0:		%{name}-fPIC.patch
Patch1:		%{name}-tinfo.patch
Patch2:		%{name}-link.patch
URL:		http://www.erlang.org/
%{?with_java:BuildRequires:	/usr/bin/jar}
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	flex
%{?with_java:BuildRequires:	jdk >= 1.2}
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel >= 0.9.7
BuildRequires:	openssl-tools
BuildRequires:	perl-base
%if %{with odbc}
BuildRequires:	unixODBC-devel
%else
BuildConflicts:	unixODBC-devel
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define _erl_target %(echo %{_build}-gnu | sed -e's/amd64/x86_64/;s/athlon/i686/;s/ppc/powerpc/')

%description
Erlang is a programming language designed at the Ericsson Computer
Science Laboratory. Open-source Erlang is being released to help
encourage the spread of Erlang outside Ericsson.

%description -l pl.UTF-8
Erlang to język programowania opracowany w Ericsson Computer Science
Laboratory. Open-source Erlang został wydany, aby pomóc w
rozpowszechnianiu Erlanga poza Ericssonem.

%prep
%setup -q -n otp_src_%{_version}
%{__tar} xzf %{SOURCE1} man/ COPYRIGHT
#%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
find . -name config.sub | xargs -n 1 cp -f /usr/share/automake/config.sub
curd=$(pwd)
for i in $(find . -type f -name configure.in); do
	cd $(dirname $i)
	%{__autoconf}
	cd $curd
done
%configure \
%ifarch sparc
	CFLAGS="%{rpmcflags} -mv8plus" \
%endif
	--with%{!?with_java:out}-javac
rm -f lib/ssl/SKIP
ERL_TOP=`pwd`; export ERL_TOP
 %{__make} -j1 \
	TARGET="%{_erl_target}" \
	|| { find . -name erl_crash.dump | xargs cat ; exit 1 ; }

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -j1 install \
	TARGET="%{_erl_target}" \
	INSTALL_PREFIX=$RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}/erts-*/*.html

sed -i -e"s#$RPM_BUILD_ROOT##" \
	$RPM_BUILD_ROOT%{_libdir}/%{name}/bin/{erl,start,start_erl}

for l in erl erlc escript dialyzer epmd run_erl to_erl typer; do
	ln -sf %{_libdir}/%{name}/bin/$l $RPM_BUILD_ROOT%{_bindir}
done
ERTSDIR=`echo $RPM_BUILD_ROOT%{_libdir}/%{name}/erts-* | sed -e"s#^$RPM_BUILD_ROOT##"`
for l in epmd ; do
	ln -sf $ERTSDIR/bin/$l $RPM_BUILD_ROOT%{_bindir}
done
ln -sf $ERTSDIR/bin/epmd $RPM_BUILD_ROOT%{_libdir}/%{name}/bin

cp -r man $RPM_BUILD_ROOT%{_libdir}/%{name}
find $RPM_BUILD_ROOT%{_libdir}/%{name}/man -type f | xargs gzip -9

# some files in the library need +x, so we build the list here
echo "%%defattr(644,root,root,755)" > lib.list
find $RPM_BUILD_ROOT%{_libdir}/%{name}/lib -type d \
	| sed -e"s#^$RPM_BUILD_ROOT%{_libdir}/%{name}/#%%dir %%{_libdir}/%%{name}/#" >> lib.list
find $RPM_BUILD_ROOT%{_libdir}/%{name}/lib -type f -perm -500 \
	| sed -e"s#^$RPM_BUILD_ROOT%{_libdir}/%{name}/#%%attr(755,root,root) %%{_libdir}/%%{name}/#" >> lib.list
find $RPM_BUILD_ROOT%{_libdir}/%{name}/lib -type f '!' -perm -500 \
	| sed -e"s#^$RPM_BUILD_ROOT%{_libdir}/%{name}/#%%{_libdir}/%%{name}/#" >> lib.list

rm -rf $RPM_BUILD_ROOT%{_libdir}/%{name}/erts-*/lib
rm -rf $RPM_BUILD_ROOT%{_libdir}/%{name}/erts-*/include/internal

%clean
rm -rf $RPM_BUILD_ROOT

%files -f lib.list
%defattr(644,root,root,755)
%doc AUTHORS EPLICENCE COPYRIGHT
%attr(755,root,root) %{_bindir}/*
%dir %{_libdir}/erlang
%dir %{_libdir}/%{name}/bin
%attr(755,root,root) %{_libdir}/%{name}/bin/ct_run
%attr(755,root,root) %{_libdir}/%{name}/bin/dialyzer
%attr(755,root,root) %{_libdir}/%{name}/bin/epmd
%attr(755,root,root) %{_libdir}/%{name}/bin/erl
%attr(755,root,root) %{_libdir}/%{name}/bin/erlc
%attr(755,root,root) %{_libdir}/%{name}/bin/escript
%attr(755,root,root) %{_libdir}/%{name}/bin/run_erl
%attr(755,root,root) %{_libdir}/%{name}/bin/run_test
%attr(755,root,root) %{_libdir}/%{name}/bin/start
%attr(755,root,root) %{_libdir}/%{name}/bin/start_erl
%attr(755,root,root) %{_libdir}/%{name}/bin/to_erl
%attr(755,root,root) %{_libdir}/%{name}/bin/typer
%{_libdir}/%{name}/bin/start*.*
%dir %{_libdir}/%{name}/erts-*
%{_libdir}/%{name}/erts-*/doc
%{_libdir}/%{name}/erts-*/man
%{_libdir}/%{name}/erts-*/src
%{_libdir}/%{name}/erts-*/include
#%{_libdir}/%{name}/erts-*/*.ear
%dir %{_libdir}/%{name}/erts-*/bin
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/beam*
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/child*
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/ct_run
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/dialyzer
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/dyn_erl
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/e*
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/heart*
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/inet_gethost
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/run_erl
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/start
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/to_erl
%attr(755,root,root) %{_libdir}/%{name}/erts-*/bin/typer
%{_libdir}/%{name}/erts-*/bin/start*.*
# (file list dynamically generated) %{_libdir}/%{name}/lib
%dir %{_libdir}/%{name}/misc
%attr(755,root,root) %{_libdir}/%{name}/misc/*
%{_libdir}/%{name}/releases
%{_libdir}/%{name}/usr
%doc %{_libdir}/%{name}/man
%attr(755,root,root) %{_libdir}/%{name}/Install

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: erlang.spec,v $
Revision 1.65  2012/01/13 20:59:53  arekm
- release 3

Revision 1.64  2011/08/31 18:27:46  arekm
- release 2

Revision 1.63  2011/07/19 06:17:11  arekm
- up to R14B03

Revision 1.62  2011/01/10 11:19:00  arekm
- up to R14B01; replace strcpy with memcpy because fortify source won't allow to strcpy into too short array

Revision 1.61  2010/09/02 08:23:59  arekm
- rel 1.1; A is unstable it seems :/

Revision 1.60  2010/09/02 08:20:40  arekm
- up to R14A

Revision 1.59  2010/04/17 18:43:13  arekm
- rel 4; some git fixes

Revision 1.58  2010/04/17 18:36:46  arekm
- release 3

Revision 1.57  2010/04/11 17:04:57  arekm
- release 2

Revision 1.56  2010/03/01 08:09:40  arekm
- up to R13B04

Revision 1.55  2010/01/01 22:33:01  sparky
- BR capitalization

Revision 1.54  2009/04/05 15:09:37  arekm
- stable note

Revision 1.53  2009/01/15 12:51:32  arekm
- up to r12b_5

Revision 1.52  2008/10/13 18:46:45  arekm
- up to R12B_4

Revision 1.51  2008-06-08 13:17:56  japhy
- Patch for correct openssl-devel detection with --as-needed
- rel 2, STBR

Revision 1.50  2008-05-14 05:04:31  tommat
- typo

Revision 1.49  2008-05-14 05:03:29  tommat
- rel 1, builds

Revision 1.48  2008-05-13 23:21:28  tommat
- docs are versioned too

Revision 1.47  2008-05-13 23:09:57  tommat
- version R12B_2
- added patch to build with glibc 2.8
- no parallel install
- rel 0.1 builds at least on i686

Revision 1.46  2008-05-13 20:42:26  tommat
- ugly workaround for sparc32, assembler insertions require v8plus arch

Revision 1.45  2008-04-05 17:43:30  dzeus
- rel.2

Revision 1.44  2008-03-31 12:25:11  shadzik
- recursive removing? no thanks :) (it's just a file)

Revision 1.43  2008-03-31 12:05:51  shadzik
- force lib/ssl packaging, ejabberd needs this for example

Revision 1.42  2008-02-22 14:58:17  arekm
- up to R12B_1

Revision 1.41  2007/10/01 16:24:25  arekm
- up to R11B_5

Revision 1.40  2007/02/12 21:23:54  glen
- tabs in preamble

Revision 1.39  2007/02/12 00:48:48  baggins
- converted to UTF-8

Revision 1.38  2007/02/03 23:48:33  arekm
- up to R11B_3; fix symlinks pointing to nowhere

Revision 1.37  2006/12/14 09:45:06  deejay1
- up to R11B_2

Revision 1.36  2006/09/28 08:35:51  deejay1
- up to R11B_1
- TODO still valid

Revision 1.35  2006/08/24 11:56:09  arekm
- rel 3

Revision 1.34  2006/08/09 06:58:33  arekm
- rel 2

Revision 1.33  2006/06/19 06:36:11  glen
- more todo

Revision 1.32  2006/06/19 06:35:08  glen
- add todo!

Revision 1.31  2006/05/21 18:05:04  deejay1
- up to R11B_0 - now with SMP
- cleanup changelog

Revision 1.30  2006/04/02 17:12:47  arekm
- no LD_ASSUME_KERNEL for Th

Revision 1.29  2006/04/01 20:47:08  arekm
- th BR: xorg-lib-libX11-devel

Revision 1.28  2006/04/01 19:42:59  deejay1
- oops, docs weren't updated - sorry :(

Revision 1.27  2006/04/01 19:38:47  deejay1
- up to R10_B10

Revision 1.26  2006/02/28 23:37:25  glen
- adapterized (killed trailing spaces/tabs)

Revision 1.25  2005/12/24 13:02:48  arekm
- add note about dns

Revision 1.24  2005/12/16 15:18:36  deejay1
- rel. 1, SOA #1

Revision 1.23  2005/12/14 17:41:57  deejay1
- updated to R10B_9
- added unixODBC bcond

Revision 1.22  2005/09/29 18:57:03  jajcus
- thread problems? maybe LD_ASSUME_KERNEL=2.4.19 will help

Revision 1.21  2005/09/29 09:20:51  jajcus
- a little fix to the debuging code

Revision 1.20  2005/09/29 08:45:17  jajcus
- a bit of %build debugging code...

Revision 1.19  2005/09/28 10:47:08  jajcus
- Release: 1

Revision 1.18  2005/09/27 20:57:46  jajcus
- Version: R10B_7
- simple Makefile fix for %install (-hipe_optimistic_regalloc_once_only.patch)

Revision 1.17  2005/08/04 19:08:14  deejay1
- BR: openssl-devel >= 0.9.7 and openssl-tools for ssl support

Revision 1.16  2005/08/04 15:03:59  deejay1
- updated to R10B-6
- removed obsolete patch

Revision 1.15  2005/06/08 20:30:37  zawadaa
- up to R10B-5
- builds, needs some patch checks

Revision 1.14  2004/12/17 13:47:13  jajcus
- starting update to version R10B_2

Revision 1.13  2004/10/11 07:35:26  jajcus
- oops... Release: 3, that should be done before sending the build request.

Revision 1.12  2004/10/10 21:19:15  jajcus
- --with java bcond

Revision 1.11  2004/09/02 19:07:52  aredridel
- BR: fastjar

Revision 1.10  2004/09/02 06:06:50  jajcus
- BR erlang.spec

Revision 1.9  2004/09/01 22:14:28  jajcus
- fix building on athlon and powerpc
- set (755,root,root) on files which require it in the standard library (makes SSL module work)
- patch for ssl timeout problem (http://article.gmane.org/gmane.comp.lang.erlang.patches/65)

Revision 1.8  2004/09/01 11:36:43  jajcus
- AMD64 fixes

Revision 1.7  2004/08/31 21:31:46  jajcus
- previous MD5 sum and unnpackaging command were for corrupted tarball

Revision 1.6  2004/08/31 20:15:38  jajcus
- package renamed from "otp" to "erlang"
- manual pages added (into erlang directory hierarchy because some of them
  conflict with system manual pages) to be read with: erl -man page

Revision 1.5  2004/08/31 20:01:39  qboosh
- missing dirs

Revision 1.4  2004/08/30 22:00:58  jajcus
- builds and seems to work

Revision 1.3  2004/08/30 15:00:51  qboosh
- pl, cosmetics, BR: autoconf

Revision 1.2  2004/08/30 14:33:02  twittner
- make distfiles happy (maybe) - use tr instead of sed.

Revision 1.1  2004/08/30 13:57:41  jajcus
- new spec (maybe it should be erlang.spec). Not finished yet\!
